/*
btget.c Version 0.2.0  Btree get record
Copyright (C) 2003-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* if record is not FOUND */
/* btget returns the next higher record */
/* with a return code of NOTFOUND */

#include <bthash.h>

int btget(bthdr,ofst,key,buf)
btreefmt *bthdr;
off_t ofst;
unsigned char *key;
unsigned char *buf;
   {
   int rslt;
   int btgrslt;
   int currcd;
   unsigned char *p,*q,*r;
   unsigned char *rcdptr;
   bt_nodefmt *node;
   bthdr->reason = 0;
   bthdr->rcdnum = 0;
   btgetblk(bthdr,ofst);
   if (bthdr->reason)
      return(BTREE_ERR + 2001);
   rcdptr = (unsigned char *) bthdr->blk + bthdr->blkhdr;
   currcd = 1;
   while (currcd <= bthdr->blk->count)
      {
      p = (unsigned char *) rcdptr
	 + bthdr->rcdhdr + bthdr->keyofst;
      q = (unsigned char *) p + bthdr->keylen;
      r = key;
      while (p < q)
	 {
	 rslt = *r - *p;
	 if (rslt) break;
	 p++;
	 r++;
	 } /* for each byte in key */
      if (!rslt)
	 {
	 p = (unsigned char *) rcdptr + bthdr->rcdhdr;
	 bthdr->rcd = (unsigned char *) p;
	 bthdr->key = (unsigned char *) p + bthdr->keyofst;
	 bthdr->dletbyte = (unsigned char *) p + bthdr->dletofst;
	 bthdr->rcdnum = currcd;
	 if (*(p + bthdr->dletofst) == DELETED)
	    {
	    bthdr->reason = BTREE_ERR + 2002;
	    return(NOTFOUND);
	    } /* deleted record matches key */
	 if (buf != NULL)
	    {
	    q = (unsigned char *) p + bthdr->rcdlen;
	    r = (unsigned char *) buf;
	    while (p < q) *r++ = *p++;
	    } /* if buf specified */
	 node = (bt_nodefmt *) rcdptr;
	 if (node->left)
	    bthdr->reason = INDXNODE;
	 else
	    bthdr->reason = LEAFNODE;
	 return(FOUND);
	 } /* if match */
      else if (rslt > 0)
	 {
	 if (currcd < bthdr->blk->count)
	    {
	    rcdptr = (unsigned char *) rcdptr + bthdr->rcdnode;
	    currcd++;
	    continue;
	    } /* if not end of block */
	 else /* if end of block */
	    {
	    if (bthdr->blk->right)
	       {
               return(btget(bthdr,bthdr->blk->right,key,buf));
	       } /* if right pointer */
	    else /* end of block && no right pointer */
	       {
	       bthdr->rcdnum = 0;
	       bthdr->reason = FRSTPAPA;
	       return(FRSTPAPA);
	       } /* if not found */
	    } /* if end of block */
	 } /* if greater than */
      else if (rslt < 0)
	 {
	 node = (bt_nodefmt *) rcdptr;
	 if (node->left)
	    {
            btgrslt = btget(bthdr,node->left,key,buf);
	    /* do not test bthdr->reason at this point */
	    if (btgrslt == FRSTPAPA)
	       {
               btgetblk(bthdr,ofst);
               if (bthdr->reason)
                  return(BTREE_ERR + 2003);
               r = (unsigned char *) rcdptr + bthdr->rcdhdr;
	       bthdr->rcd = (unsigned char *) r;
	       if (buf != NULL)
	          {
                  p = (unsigned char *) buf;
                  q = (unsigned char *) buf + bthdr->rcdlen;
                  while (p < q) *p++ = *r++;
	          } /* if buf specified */
               bthdr->reason = FRSTPAPA;
               bthdr->rcdnum = currcd;
               return(NOTFOUND);
               } /* if get first parent to right */
	    else return(btgrslt);
	    } /* if left pointer */
	 else
	    {
	    p = (unsigned char *) rcdptr + bthdr->rcdhdr;
	    bthdr->rcd = (unsigned char *) p;
	    if (buf != NULL)
	       {
	       q = (unsigned char *) p + bthdr->rcdlen;
	       r = (unsigned char *) buf;
	       while (p < q) *r++ = *p++;
	       } /* if buf specified */
	    bthdr->rcdnum = currcd;
	    bthdr->reason = LEAFNODE;
	    return(NOTFOUND);
	    } /* if not found */
	 } /* if less than */
      } /* for each record in node */
   bthdr->reason = FRSTPAPA;
   return(FRSTPAPA);
   } /* btget */
