/*
hsize.c Version 0.2.0  Hash counts records in database
Copyright (C) 2003-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* returns total records, total overflow */
/* total empty slots and total free blocks */
/* in database */

#include <bthash.h>

void hsize(hshhdr,rcds,ovfl,empty,freeblk)
hashfmt *hshhdr;
int *rcds;
int *ovfl;
int *empty;
int *freeblk;
   {
   int eofsw,rdlen;
   int tot;
   h_nodefmt *blk;
   off_t loc;
   off_t ofst;
   off_t hashend;
   unsigned char *p,*q;
   unsigned char buf[65536 + 16];
   hshhdr->reason = 0;
   loc = lseek(hshhdr->hndl,
      HDRLEN,
      SEEK_SET);
   if (loc != HDRLEN)
      {
      perror("hsize: lseek err");
      hshhdr->reason = SYS_ERR + errno;
      return;
      } /* if lseek err */
   *rcds = *ovfl = *empty = *freeblk = 0;
   tot = eofsw = 0;
   blk = (h_nodefmt *) buf;
   hashend = (off_t) hshhdr->hashend;
   ofst = HDRLEN;
   while (!eofsw)
      {
      rdlen = read(hshhdr->hndl,buf,hshhdr->rcdnode);
      if (rdlen < 0)
	 {
         perror("hsize: read error");
         hshhdr->reason = SYS_ERR + errno;
         return;
	 } /* read err */
      if (rdlen == hshhdr->rcdnode)
	 {
	 tot++;
	 p = (unsigned char *) buf
	    + hshhdr->rcdhdr
	    + hshhdr->keyofst;
	 q = (unsigned char *) p + hshhdr->keylen;
	 while (p < q)
	    {
	    if (*p != 0xff) break;
	    p++;
	    } /* for each byte in key */
	 if (ofst >= hashend
	    && p < q)
	    {
            (*ovfl)++;
	    } /* if overflow */
	 /* if record key is all ff */
	 /* count it as a free block */
	 if (p >= q)
	    (*freeblk)++;
	 else if (blk->next == UINT_MAX)
	    (*empty)++;
	 else
            (*rcds)++;
	 ofst += hshhdr->rcdnode;
	 } /* if good read */
      else if (!rdlen)
	 {
	 eofsw = 1;
         break;
	 } /* eof */
      else
	 {
         fprintf(stderr,"hsize: read error\n");
         fprintf(stderr,"hshhdr->rcdnode %d "
	    "rdlen %d\n",
	    hshhdr->rcdnode, rdlen);
         hshhdr->reason = HASH_ERR + 1201;
         return;
	 } /* read err */
      } /* for each block in db */
   } /* hsize */
